# Načtení matice ze souboru.
from array_fun import map_array
from file import parse_lines, load_file_content
# Vrácení pole řetězců oddělených bílými znaky.
"""
>>> "  a\nb c  d  ".split()
['a', 'b', 'c', 'd']
"""
# Napište funkci, která převede řetězec na řádek matice.
def parse_row(row_string):
    cells_string = row_string.split()
    return map_array(int, cells_string)    
"""
>>> parse_row('1 2 3')
[1, 2, 3]
"""
# Napište funkci, která zkontroluje,
# že má matice všechny řádky stejně dlouhé.
def matrix_rows_size_check(matrix):
    first_row = matrix[0]
    size = len(first_row)
    for row in matrix:
        if len(row) != size:
            raise ValueError('All rows have to have equal size.')    
"""
>>> matrix_rows_size_check([[1, 2], [3]])
ValueError: All rows have to have equal size.
>>> matrix_rows_size_check([[1, 2], [3, 4]])
"""
# Napište funkci, která převede řetězec na matici.
def parse_matrix(matrix_string):
    try:
        rows_string = parse_lines(matrix_string)
        matrix =  map_array(parse_row, rows_string)
        matrix_rows_size_check(matrix)
        return matrix
    except Exception as exception:
        raise RuntimeError(f"Can not parse matrix:\
{repr(matrix_string)}") from exception

"""
>>> parse_matrix('1 2 3\n6 8 2\n9 5 2')
[[1, 2, 3], [6, 8, 2], [9, 5, 2]]
>>> parse_matrix('1 2 3\n6 8\n9 5 2')
RuntimeError: Can not parse matrix: '1 2 3\n6 8\n9 5 2'
>>> parse_matrix("1 2\n 3a 12")
RuntimeError: Can not parse matrix: '1 2\n 3a 12'
"""

# matrix.txt:
"""
1 2 3
6 8 2
9 5 2
"""
def load_matrix(path):
    return parse_matrix(load_file_content(path))
"""
>>> load_matrix("matrix.txt")
[[1, 2, 3], [6, 8, 2], [9, 5, 2]]
"""


