# Zpracování souboru po řádcích.
"""
file = open("movies/movie.tsv",encoding="UTF-8")
try:
    end = False
    while not end:
        line = file.readline()
        if line == "":
            end = True
        else:
            print(line)
finally:
    file.close()
"""
def parse_tsv_line(row):
    return row.replace("\n", "").split("\t")
"""
>>> parse_tsv_line('tt0033290\tYoung as You Feel\t1940\t60\n')
['tt0033290', 'Young as You Feel', '1940', '60']
>>> parse_tsv_line('tt0033290\tYoung as You Feel\t1940\t60')
['tt0033290', 'Young as You Feel', '1940', '60']
>>> parse_tsv_line('tt0033290\tYoung as You Feel\t1940\t\n')
['tt0033290', 'Young as You Feel', '1940', '']
"""
def int_parse(string):
    if string == "":
        return None
    else:
        return int(string)
"""
>>> int_parse("1940")
1940
>>> int_parse("")
>>>
"""
def parse_movie(line):
    row = parse_tsv_line(line)
    return row[:2] + [int_parse(row[2]), int_parse(row[3])]
"""
>>> parse_movie('tt0033290\tYoung as You Feel\t1940\t60\n')
['tt0033290', 'Young as You Feel', 1940, 60]
>>> parse_movie('tt0033290\tYoung as You Feel\t1940\t')
['tt0033290', 'Young as You Feel', 1940, None]
"""

def get_movie_title(movie):
    return movie[1]

def get_movie_year(movie):
    return movie[2]

# Úkol: Kdy byl natočen zadaný film?
# "The Matrix" => 1999

def get_movie_year_by_title(title):
    file = open("movies/movie.tsv")
    try:
        end = False
        while not end:
            line = file.readline()
            if line == "":
                end = True
            else:
                movie = parse_movie(line)
                if get_movie_title(movie) == title:
                    return get_movie_year(movie)
    finally:
        file.close()


# Úkol: V kterých filmech hrál zadaný herec?
                    
                
                
"""
>>> get_movie_year_by_title("The Matrix")
1999
"""
